/*
 * HTML5 Sortable jQuery Plugin
 * http://farhadi.ir/projects/html5sortable
 * 
 * Copyright 2012, Ali Farhadi
 * Released under the MIT license.
 */
(function($) {
var dragging, placeholders = $();
$.fn.sortable = function(options) {
	var method = String(options);
	//showObj("options:",options);
	options = $.extend({
		connectWith: false
	}, options);
	
	return this.each(function() {  //loop for each list
		//-------------skip
		if (/^enable|disable|destroy$/.test(method)) {
			var items = $(this).children($(this).data('items')).attr('draggable', method == 'enable');
			
			if (method == 'destroy') {
				items.add(this).removeData('connectWith items')
					.off('dragstart.h5s dragend.h5s selectstart.h5s dragover.h5s dragenter.h5s drop.h5s');
			}
			return;
		}
		//--------------begin------
		//showObj("$(this)",$(this).context);
		
		var isHandle, index, items = $(this).children(options.items);
		var placeholderStr = '<' + (/^ul|ol$/i.test(this.tagName) ? 'li' : 'div') + ' class="sortable-placeholder">';
		//alert(placeholderStr);
		var placeholder = $(placeholderStr);
		//var placeholder = $('<' + (/^ul|ol$/i.test(this.tagName) ? 'li' : 'div') + ' class="sortable-placeholder">');
		//showObj("items",items);
		//showObj("this:",$(this));
		//alert(items.length);
		items.find(options.handle).mousedown(function() {
			isHandle = true;
		}).mouseup(function() {
			isHandle = false;
		});
		$(this).data('items', options.items)
		placeholders = placeholders.add(placeholder);
		//showObj("options.connectWith",options.connectWith);
		if (options.connectWith) {
			$(options.connectWith).add(this).data('connectWith', options.connectWith);
		}
		//----------------
		
		items.attr('draggable', 'true')
		.on('dragstart.h5s', function(e) {
			//alert("in dragstart");
			
			
			if (options.handle && !isHandle) {
				return false;
			}
			
			isHandle = false;
			var dt = e.originalEvent.dataTransfer;
			dt.effectAllowed = 'move';
			dt.setData('Text', 'dummy');
			index = (dragging = $(this)).addClass('sortable-dragging').index();
			//alert("index:"+index);
		})//end of .
		.on('dragend.h5s', function() {
			//alert("in dragend");
			//----------test
			//showObj(placeholder);
			//----------test
			if (!dragging) {
				return;
			}
			//alert( $(this).data.("id"));
			//alert( $(this).attr('name'));
			var className = $(this).parent().attr('stlName');
			//dragging.removeClass('sortable-dragging').show();
			dragging.removeClass().addClass(className).show();
			placeholders.detach();
			if (index != dragging.index()) {
				dragging.parent().trigger('sortupdate', {item: dragging});
			}
			dragging = null;
		})//end of .on
		
		.not('a[href], img')
		.on('selectstart.h5s', function() {
			//alert("in selectstart");
			this.dragDrop && this.dragDrop();
			return false;
		})//end of .not .on
		
		.end().add([this, placeholder])
		.on('dragover.h5s dragenter.h5s drop.h5s', function(e) {
			//alert("dragover,dragenter,drop");
			//---------test
			//showObj(this);
			if (!items.is(dragging) && options.connectWith !== $(dragging).parent().data('connectWith')) {
				return true;
			}
			if (e.type == 'drop') {
				e.stopPropagation();
				placeholders.filter(':visible').after(dragging);
				dragging.trigger('dragend.h5s');
				return false;
			}
			e.preventDefault();
			e.originalEvent.dataTransfer.dropEffect = 'move';
			if (items.is(this)) {
				if (options.forcePlaceholderSize) {
					placeholder.height(dragging.outerHeight());
				}
				dragging.hide();
				//alert("this index:"+$(this).index());
				//alert("placeholder index:"+ placeholder.index());
				var beforAfter = placeholder.index() < $(this).index() ? 'after' : 'before';
				if(beforAfter=='before'){
					//alert(beforAfter);
				}
				$(this)[beforAfter](placeholder);
				placeholders.not(placeholder).detach();
			} else if (!placeholders.is(this) && !$(this).children(options.items).length) {
				placeholders.detach();
				$(this).append(placeholder);
			}
			return false;
		});//end of .end().add.on
	});//end of each
};
})(jQuery);
